#!/usr/bin/perl -w

# check the process to make sure that the process setting is correct,
# the full core can be generated. 
# 6/13/2008  Wei Luo weiluo@us.ibm.com


if (@ARGV  != 1) {

   print "WARNING Should enter  exactly one arguments\n";
   print "Usage: check_ulimit.pl <java process id> \n\n";
   exit 1;
}

check_sys();

sub check_sys {

   my $userid="";
   my $psize=0;
   my $alarm=0;
   @psinfo=();
   
   $psinfo=`ps auw | grep $ARGV[0] | grep -v grep`;

   if ( $? == 0 ) {
      chomp($psinfo);
      @psinfo=split(/\s+/,$psinfo);
   }

   if ( @psinfo > 1 ) {
      $userid=$psinfo[0];
   }

   $meminfo=` svmon -P $ARGV[0] | grep $ARGV[0]`;

   if ($? == 0) {
      chomp($meminfo);
      @meminfo=split(/\s+/,$meminfo);
   }

   if ( @meminfo > 1 ) {
      $psize=$meminfo[6];
   } 

    $line=`echo "dcal $ARGV[0] " | kdb | grep "Value decimal" | grep -v grep `; 
    if ( $? == 0 ) {
      chomp($line);
      @line=split(/\s+/,$line);
   }

    foreach $_ (`echo "tpid $line[5]" | kdb `) {
      @words = split;
      if (/^pvthread/ ) {
         if ($words[3] ne "ZOMB") {
            $tid = $words[1];
         }
      }
   }

   foreach $_ (`echo "user -ru $tid " | kdb `) {
      chomp($_);
      @words = split;
      @re_words = reverse(@words);

      if (/^   rlimit\[FSIZE\]/ || /^   rlimit\[DATA\]/ || /^   rlimit\[CORE\]/) {
         if ($re_words[2] ne "7FFFFFFF" ) {
            $alarm=1;
         }
      }
   }

  if ( $alarm ) {
     `echo "user -ru $tid " | kdb >> ulimit.out `;
     print "\n The java process $ARGV[0] doesn't have correct ulimit settings, \n ";
     print "The core file will be truncated....\n" ;

  }

  foreach $_ (`lsattr -El sys0`) {
     my @words2=split;

     if (/fullcore/) {
       if ($words2[1] eq "false") {
          print "\nThe system doesn't enable the fullcore dump, the core file will be truncated,\n\n";
          print " please run \"chdev -l sys0 -a fullcore=true \" command as root. \n\n";
        }
     }
  }

  $psize = int ((($psize*4)/1024) + 300);

  $corepath = `syscorepath -g`;
  chomp ($corepath);
  #print "corepath: $corepath\n";
  if ($corepath eq "") {
     $corepath=`pwd`;
     chomp($corepath);
  }

  if (system ("su $userid -c touch $corepath/.touch.core.$$")) {
     print "The user $userid doesnt' have write permision in directory $corepath.  \n";
     $alarm=1;
  } else {
     system "/usr/bin/rm -f $corepath/.touch.core.$$";
     print "Core file is likely generated under $corepath\n";
  }

  open (FD, "df -k $corepath | grep -v Free|");
  @fr=<FD>;
  close(FD);
  @f=split(/\s+/,$fr[0]);

  $f[2]/=1024;
  $space = int ($f[2] - $psize);

  if ( $space < 0 ) {
     print "\nNeed $psize MB disk space for data collection.\n";
     printf "you currently have %d ", $f[2]  ;
     printf "MB available, it may not be enough.\n\n";
  }

} 

